#include <iostream>
#include <vector>
#include <list>
#define size 20001
using namespace std;
int to_index(int v);
void isReachableDestinations (bool R[100], int n, int T[100][2], bool map[size][size]);


int main()
{
	int n = 0, m = 0;					// number of destination n, closed road m
	list< pair<int, int> > nList;		// destination point
	pair<int, int> pTmp;				// point x, y
	list< pair<int, int> >::iterator it;
	vector< vector<int> > map(size, vector<int>(size,false));	// city
	int tmp1 = 0, tmp2 = 0;	
	int x1 = 0, y1 = 0, x2 = 0, y2 =0;	// two endpoints of closed road

	while (cin >> n >> m)
	{
		// init map
		nList.clear();
		for (int i = 0; i < size; i++)
		{
			for (int j = 0; j < size; j++)
				map[i][j] = false;
		}
		
		// set destination point
		for (int i = 0; i < n; i++)
		{
			cin >> tmp1 >> tmp2;
			pTmp.first = tmp1;
			pTmp.second = tmp2;

			nList.push_back(pTmp); 
		}

		// draw the map of city
		for (int i = 1; i <= m; i++)
		{
			cin >> x1 >> y1 >> x2 >> y2;

			if (x1 == x2 && y2 >= y1)
			{
				for (int k = y1; k <= y2; k++)
					map[to_index(x1)][to_index(k)] = true;
			}
			else if (x1 == x2 && y2 < y1)
			{
				for (int k = y2; k <= y1; k++)
					map[to_index(x1)][to_index(k)] = true;
			}
			else if (y1 == y2 && x2 >= x1)
			{
				for (int k = x1; k <= x2; k++)
					map[to_index(k)][to_index(y1)] = true;
			}
			else if (y1 == y2 && x2 < x1)
			{
				for (int k = x2; k <= x1; k++)
					map[to_index(k)][to_index(y1)] = true;
			}
		}

		bool isReachable1 = true, isReachable2 = true;
		int number = 1;
		for ( it = nList.begin(); it != nList.end(); ++it) 
		{
			isReachable1 = true;
			isReachable2 = true;

			// cout << i+1 << " ";
			if ((*it).first >= 0 && (*it).second >= 0) // +, +
			{
				// 先往右，再向上
				for (int x = 0; x <= (*it).first; x++)
				{
					if (map[to_index(x)][to_index(0)]) // 向右走
						isReachable1 = false;					
				}
				for (int y = 0; y <= (*it).second; y++)
				{
					if (map[to_index((*it).first)][to_index(y)])  // 向上走
						isReachable1 = false;
				}
				// 先往上，再向右
				for (int y = 0; y <= (*it).second; y++)
				{
					if (map[to_index(0)][to_index(y)])  // 向上走
						isReachable2 = false;
				}
				for (int x = 0; x <= (*it).first; x++)
				{
					if (map[to_index(x)][to_index((*it).second)]) // 向右走
						isReachable2 = false;					
				}
			}	// end +, +
			else if ((*it).first >= 0 && (*it).second <= 0) // +, -
			{
				// 先往右，再向上
				for (int x = 0; x <= (*it).first; x++)
				{
					if (map[to_index(x)][to_index(0)]) // 向右走
						isReachable1 = false;					
				}
				for (int y = (*it).second; y <= 0; y++)
				{
					if (map[to_index((*it).first)][to_index(y)])  // 向上走
						isReachable1 = false;
				}
				// 先往上，再向右
				for (int y = (*it).second; y <= 0; y++)
				{
					if (map[to_index(0)][to_index(y)])  // 向上走
						isReachable2 = false;
				}
				for (int x = 0; x <= (*it).first; x++)
				{
					if (map[to_index(x)][to_index((*it).second)]) // 向右走
						isReachable2 = false;				
				}
			} // end +, -			
			else if ((*it).first <= 0 && (*it).second >= 0) // -, +
			{
				// 先往右，再向上
				for (int x = (*it).first; x <= 0; x++)
				{
					if (map[to_index(x)][to_index(0)]) // 向右走
						isReachable1 = false;				
				}
				for (int y = 0; y <= (*it).second; y++)
				{
					if (map[to_index((*it).first)][to_index(y)])  // 向上走
						isReachable1 = false;
				}
				// 先往上，再向右
				for (int y = 0; y <= (*it).second; y++)
				{
					if (map[to_index(0)][to_index(y)])  // 向上走
						isReachable2 = false;
				}
				for (int x = (*it).first; x <= 0; x++)
				{
					if (map[to_index(x)][to_index((*it).second)]) // 向右走
						isReachable2 = false;				
				}
			}	// end -, +
			else if ((*it).first <= 0 && (*it).second <= 0) // -, -
			{
				// 先往右，再向上
				for (int x = (*it).first; x <= 0; x++)
				{
					if (map[to_index(x)][to_index(0)]) // 向右走
						isReachable1 = false;				
				}
				for (int y = (*it).second; y <= 0; y++)
				{
					if (map[to_index((*it).first)][to_index(y)])  // 向上走
						isReachable1 = false;
				}
				// 先往上，再向右
				for (int y = (*it).second; y <= 0; y++)
				{
					if (map[to_index(0)][to_index(y)])  // 向上走
						isReachable2 = false;
				}
				for (int x = (*it).first; x <= 0; x++)
				{
					if (map[to_index(x)][to_index((*it).second)]) // 向右走
						isReachable2 = false;					
				}
			}	 // end -, -

			if (isReachable1 or isReachable2)
				cout << number << " " ;

			number ++;

		} // end i loop
		cout << endl;

	}

	return 0;
}

int to_index(int v)
{
	return v+(size-1)/2;	
}